Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskTreeTestRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskTreeTestRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskTreeTestRule.java	(revision 1918)
@@ -15,7 +15,19 @@
 package de.ugoe.cs.autoquest.usability;
 
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
 import de.ugoe.cs.autoquest.eventcore.Event;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskInstanceTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTask;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ISelection;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IStructuringTemporalRelationship;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInfo;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstanceVisitor;
@@ -41,6 +53,119 @@
 
         checkTimestamps(taskModel);
+        checkTaskInfos(taskModel);
+        checkEventTaskInstances(taskModel);
+        checkTraversal(taskModel);
 
         return results;
+    }
+
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @param taskModel
+     */
+    private void checkEventTaskInstances(ITaskModel taskModel) {
+        Set<IEventTaskInstance> instancesInModel = new HashSet<>();
+        
+        for (ITask task : taskModel.getTasks()) {
+            if (task instanceof IEventTask) {
+                for (ITaskInstance instance : task.getInstances()) {
+                    instancesInModel.add((IEventTaskInstance) instance);
+                }
+            }
+        }
+        
+        final Set<IEventTaskInstance> instancesInSessions = new HashSet<>();
+        
+        for (IUserSession session : taskModel.getUserSessions()) {
+            for (ITaskInstance rootInstance : session) {
+                rootInstance.accept(new DefaultTaskInstanceTraversingVisitor() {
+                    @Override
+                    public void visit(IEventTaskInstance eventTaskInstance) {
+                        instancesInSessions.add(eventTaskInstance);
+                    }
+                });
+            }
+        }
+        
+        if (instancesInModel.size() != instancesInSessions.size()) {
+            throw new RuntimeException("instances not equal");
+        }
+        else {
+            for (IEventTaskInstance instance : instancesInModel) {
+                if (!instancesInSessions.contains(instance)) {
+                    throw new RuntimeException("instance of model not contained in sessions");
+                }
+            }
+            
+            for (IEventTaskInstance instance : instancesInSessions) {
+                if (!instancesInModel.contains(instance)) {
+                    throw new RuntimeException("instance of sessions not contained in model");
+                }
+            }
+        }
+    }
+
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @param taskModel
+     */
+    private void checkTraversal(ITaskModel taskModel) {
+        for (ITask task : taskModel.getTasks()) {
+            final List<ITask> traversal1 = new ArrayList<>();
+            
+            task.accept(new DefaultTaskTraversingVisitor() {
+                @Override
+                public void visit(IEventTask eventTask) {
+                    traversal1.add(eventTask);
+                    super.visit(eventTask);
+                }
+
+                @Override
+                public void visit(IStructuringTemporalRelationship relationship) {
+                    traversal1.add(relationship);
+                    super.visit(relationship);
+                }
+                
+            });
+            
+            final List<ITask> traversal2 = new ArrayList<>();
+            
+            task.accept(new DefaultTaskTraversingVisitor() {
+                @Override
+                public void visit(IEventTask eventTask) {
+                    traversal2.add(eventTask);
+                    super.visit(eventTask);
+                }
+
+                @Override
+                public void visit(ISelection selection) {
+                    traversal2.add(selection);
+                    super.visit(selection);
+                }
+
+                @Override
+                public void visit(ISequence sequence) {
+                    traversal2.add(sequence);
+                    super.visit(sequence);
+                }
+            });
+            
+            if (traversal1.size() != traversal2.size()) {
+                throw new RuntimeException("traversals not equal");
+            }
+            else {
+                for (int i = 0; i < traversal1.size(); i++) {
+                    if (!traversal1.get(i).equals(traversal2.get(i))) {
+                        throw new RuntimeException("traversals not equal at position " + i);
+                    }
+                }
+            }
+        }
     }
 
@@ -78,3 +203,19 @@
         
     }
+
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @param taskModel
+     */
+    private void checkTaskInfos(ITaskModel taskModel) {
+        for (ITask task : taskModel.getTasks()) {
+            ITaskInfo taskInfo = taskModel.getTaskInfo(task);
+            if (taskInfo == null) {
+                System.out.println("task " + task + " has no associated task infos");
+            }
+        }
+    }
 }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java	(revision 1918)
@@ -84,7 +84,5 @@
         int ratio = 1000 * allTextFieldInputs / statistics.getNoOfAllEvents();
 
-        // TODO comment magic numbers
-        UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-            (ratio, 900, 700, 500, 300);
+        UsabilitySmellIntensity severity = UsabilitySmellIntensity.getIntensity(ratio);
         
         if (severity != null) {
@@ -92,6 +90,6 @@
             parameters.put("textInputRatio", (ratio / 10));
 
-            results.addDefect
-                (severity, UsabilityDefectDescription.TEXT_FIELD_INPUT_RATIO, parameters);
+            results.addSmell
+                (severity, UsabilitySmellDescription.TEXT_FIELD_INPUT_RATIO, parameters);
         }
     }
@@ -117,8 +115,8 @@
                 1000 * noOfUsagesOfTextField1WithSameTextInTextField2 / noOfUsagesOfTextField2;
 
-            createTextFieldEntryRepetitionDefect(ratioTextField1, entry.textField1,
+            createTextFieldEntryRepetitionSmell(ratioTextField1, entry.textField1,
                                                  entry.textField2, results);
             
-            createTextFieldEntryRepetitionDefect(ratioTextField2, entry.textField2,
+            createTextFieldEntryRepetitionSmell(ratioTextField2, entry.textField2,
                                                  entry.textField1, results);
             
@@ -129,12 +127,11 @@
      *
      */
-    private void createTextFieldEntryRepetitionDefect(int                       ratioOfEqualEntries,
+    private void createTextFieldEntryRepetitionSmell(int                       ratioOfEqualEntries,
                                                       ITextField                textField1,
                                                       ITextField                textField2,
                                                       UsabilityEvaluationResult results)
     {
-        // TODO comment magic numbers
-        UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-            (ratioOfEqualEntries, 900, 500, 200, 100);
+        UsabilitySmellIntensity severity =
+            UsabilitySmellIntensity.getIntensity(ratioOfEqualEntries);
         
         if (severity != null) {
@@ -144,6 +141,6 @@
             parameters.put("textField2", textField2);
 
-            results.addDefect
-                (severity, UsabilityDefectDescription.TEXT_FIELD_INPUT_REPETITIONS, parameters);
+            results.addSmell
+                (severity, UsabilitySmellDescription.TEXT_FIELD_INPUT_REPETITIONS, parameters);
         }
     }
@@ -172,11 +169,5 @@
             int ratio = 1000 * noLetterOrDigitCount / allCharactersCount;
 
-            UsabilityDefectSeverity severity =
-                UsabilityDefectSeverity.getSeverity(ratio,
-                                                    100, // every 10th sign
-                                                    50, // every 20th sign
-                                                    20, // every 50th sign
-                                                    10 // every 100th sign
-                                                    );
+            UsabilitySmellIntensity severity = UsabilitySmellIntensity.getIntensity(ratio);
 
             if (severity != null) {
@@ -185,6 +176,6 @@
                 parameters.put("noLetterOrDigitRatio", (ratio / 10));
 
-                results.addDefect
-                    (severity, UsabilityDefectDescription.TEXT_FIELD_NO_LETTER_OR_DIGIT_RATIO,
+                results.addSmell
+                    (severity, UsabilitySmellDescription.TEXT_FIELD_NO_LETTER_OR_DIGIT_RATIO,
                      parameters);
             }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UnusedGUIElementsRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UnusedGUIElementsRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UnusedGUIElementsRule.java	(revision 1918)
@@ -78,6 +78,5 @@
         int ratio = 1000 * unusedGUIElements.size() / allGUIElements.size();
         
-        UsabilityDefectSeverity severity =
-            UsabilityDefectSeverity.getSeverity(ratio, 200, 100, 50, 25);
+        UsabilitySmellIntensity severity = UsabilitySmellIntensity.getIntensity(ratio);
 
         if (severity != null) {
@@ -89,6 +88,6 @@
             parameters.put("unusedGuiElements", unusedGUIElements);
             
-            results.addDefect
-                (severity, UsabilityDefectDescription.UNUSED_GUI_ELEMENTS, parameters);
+            results.addSmell
+                (severity, UsabilitySmellDescription.UNUSED_GUI_ELEMENTS, parameters);
         }
      }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationManager.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationManager.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationManager.java	(revision 1918)
@@ -48,12 +48,18 @@
      */
     private void init() {
-        //rules.add(new TextInputStatisticsRule());
-        rules.add(new MissingFeedbackRule());
-        rules.add(new EventCoverageRatioRule());
-        rules.add(new RequiredInefficientActionsRule());
-        //rules.add(new TaskCooccurrenceRule());
-        rules.add(new TargetDistanceRule());
-        //rules.add(new UnusedGUIElementsRule());
-        //rules.add(new TaskTreeTestRule());
+        rules.add(new TaskTreeTestRule());
+//        rules.add(new TextInputStatisticsRule());
+//        rules.add(new MissingFeedbackRule());
+//        rules.add(new EventCoverageRatioRule());
+//        rules.add(new TargetDistanceRule());
+//        rules.add(new RequiredInefficientActionsRule());
+//        rules.add(new DataEntryMethodChangeRule());
+        rules.add(new DefaultValueRule());
+//        rules.add(new CheckBoxMultipleSelectionRule());
+//        rules.add(new CommonTaskRateRule());
+//        rules.add(new MisleadingClickCueRule());
+//        rules.add(new DefaultCursorPositioningRule());
+//        rules.add(new UnusedGUIElementsRule());
+//        rules.add(new TaskCooccurrenceRule());
     }
 
@@ -70,40 +76,35 @@
             UsabilityEvaluationResult result = rule.evaluate(taskModel);
             interimResults.add(result);
-            Console.traceln(Level.INFO, "the rule found " + result.getAllDefects().size() +
-                            " usability defects, of which " + result.getSevereDefects().size() +
-                            " are severe.");
+            Console.traceln(Level.INFO, "the rule found " + result.getAllSmells().size() +
+                            " usability smells.");
             
-            if ((rule instanceof EventCoverageRatioRule) ||
-                (rule instanceof RequiredInefficientActionsRule) ||
-                (rule instanceof TargetDistanceRule))
-            {
-                ITask[] referredTasks = new ITask[result.getAllDefects().size()];
+            List<ITask> referredTasks = new ArrayList<ITask>();
 
-                for (int i = 0; i < result.getAllDefects().size(); i++) {
-                    referredTasks[i] =
-                        (ITask) result.getAllDefects().get(i).getDescriptionFragments().get(1);
+            for (UsabilitySmell smell : result.getAllSmells()) {
+                if (smell.getSmellingTask() != null) {
+                    referredTasks.add(smell.getSmellingTask());
                 }
+            }
                 
-                int counter = 0;
-                for (int i = 0; i < referredTasks.length; i++) {
-                    for (int j = 0; j < referredTasks.length; j++) {
-                        if (isChildOf(referredTasks[i], referredTasks[j])) {
-                            counter++;
-                            break;
-                        }
+            int counter = 0;
+            for (int i = 0; i < referredTasks.size(); i++) {
+                for (int j = 0; j < referredTasks.size(); j++) {
+                    if (isChildOf(referredTasks.get(i), referredTasks.get(j))) {
+                        counter++;
+                        break;
                     }
                 }
+            }
                 
-                if (counter > 0) {
-                    Console.traceln(Level.INFO, counter + " of the findings are duplicates in " +
-                                    "that they refer to tasks whose parent tasks are also " +
-                                    "referred by the findings");
-                }
+            if (counter > 0) {
+                Console.traceln(Level.INFO, counter + " of the findings are duplicates in " +
+                                "that they refer to tasks whose parent tasks are also " +
+                                "referred by the findings");
             }
         }
 
         UsabilityEvaluationResult result = new UsabilityEvaluationResult(taskModel, interimResults);
-        Console.println("the evaluation result contains " + result.getAllDefects().size() +
-                        " defects, of which " + result.getSevereDefects().size() + " are severe.");
+        Console.println("the evaluation result contains " + result.getAllSmells().size() +
+                        " smells.");
 
         return result;
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationResult.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationResult.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilityEvaluationResult.java	(revision 1918)
@@ -19,4 +19,5 @@
 import java.util.Map;
 
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 
@@ -33,5 +34,5 @@
     
     /** */
-    private List<UsabilityDefect> defects = new ArrayList<UsabilityDefect>();
+    private List<UsabilitySmell> smells = new ArrayList<UsabilitySmell>();
 
     /**
@@ -50,6 +51,6 @@
         this.taskModel = taskModel;
         for (UsabilityEvaluationResult result : results) {
-            for (UsabilityDefect defect : result.getAllDefects()) {
-                defects.add(defect);
+            for (UsabilitySmell smell : result.getAllSmells()) {
+                smells.add(smell);
             }
         }
@@ -59,9 +60,9 @@
      *
      */
-    public void addDefect(UsabilityDefectSeverity    severity,
-                          UsabilityDefectDescription description,
-                          Map<String, Object>        parameters)
+    public void addSmell(UsabilitySmellIntensity   intensity,
+                         UsabilitySmellDescription description,
+                         Map<String, Object>       parameters)
     {
-        defects.add(new UsabilityDefect(severity, description, parameters));
+        addSmell(null, intensity, description, parameters);
     }
 
@@ -69,6 +70,10 @@
      *
      */
-    public List<UsabilityDefect> getAllDefects() {
-        return defects;
+    public void addSmell(ITask                     smellingTask,
+                         UsabilitySmellIntensity   intensity,
+                         UsabilitySmellDescription description,
+                         Map<String, Object>       parameters)
+    {
+        smells.add(new UsabilitySmell(smellingTask, intensity, description, parameters));
     }
 
@@ -76,14 +81,6 @@
      *
      */
-    public List<UsabilityDefect> getSevereDefects() {
-        List<UsabilityDefect> severeDefects = new ArrayList<UsabilityDefect>();
-
-        for (UsabilityDefect defect : defects) {
-            if (defect.getSeverity() == UsabilityDefectSeverity.HIGH) {
-                severeDefects.add(defect);
-            }
-        }
-
-        return severeDefects;
+    public List<UsabilitySmell> getAllSmells() {
+        return smells;
     }
 
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilitySmell.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilitySmell.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/UsabilitySmell.java	(revision 1918)
@@ -0,0 +1,172 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.util.List;
+import java.util.Map;
+
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class UsabilitySmell {
+
+    /** */
+    private ITask smellingTask;
+    
+    /** */
+    private UsabilitySmellIntensity intensity;
+
+    /** */
+    private UsabilitySmellDescription description;
+
+    /** */
+    private Map<String, Object> descriptionParameters;
+
+    /**
+     *
+     */
+    UsabilitySmell(UsabilitySmellIntensity intensity, UsabilitySmellDescription description) {
+        this(intensity, description, null);
+    }
+    
+    /**
+     *
+     */
+    UsabilitySmell(ITask                     smellingTask,
+                   UsabilitySmellIntensity   intensity,
+                   UsabilitySmellDescription description)
+    {
+        this(intensity, description, null);
+    }
+
+    /**
+     *
+     */
+    UsabilitySmell(UsabilitySmellIntensity   intensity,
+                   UsabilitySmellDescription description,
+                   Map<String, Object>       parameters)
+    {
+        this(null, intensity, description, parameters);
+    }
+
+    /**
+     *
+     */
+    UsabilitySmell(ITask                     smellingTask,
+                   UsabilitySmellIntensity   intensity,
+                   UsabilitySmellDescription description,
+                   Map<String, Object>       parameters)
+    {
+        this.smellingTask = smellingTask;
+        this.intensity = intensity;
+        this.description = description;
+        this.descriptionParameters = parameters;
+    }
+
+    /**
+     * 
+     */
+    public ITask getSmellingTask() {
+        return smellingTask;
+    }
+
+    /**
+     * 
+     */
+    public UsabilitySmellIntensity getIntensity() {
+        return intensity;
+    }
+
+    /**
+     *
+     */
+    public void setIntensity(UsabilitySmellIntensity intensity) {
+        this.intensity = intensity;
+    }
+
+    /**
+     *
+     */
+    public void setDescription(UsabilitySmellDescription description) {
+        this.description = description;
+    }
+
+    /**
+     * 
+     */
+    public String getParameterizedDescription() {
+        return description.toString(descriptionParameters);
+    }
+
+    /**
+     * 
+     */
+    public List<Object> getDescriptionFragments() {
+        return description.toFragmentList(descriptionParameters);
+    }
+
+    /*
+     */
+    public String getBriefDescription() {
+        return description.getBriefDescription();
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see java.lang.Object#equals(java.lang.Object)
+     */
+    @Override
+    public boolean equals(Object obj) {
+        if (obj instanceof UsabilitySmell) {
+            return description.equals(((UsabilitySmell) obj).description);
+        }
+        else {
+            return false;
+        }
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see java.lang.Object#hashCode()
+     */
+    @Override
+    public int hashCode() {
+        return description.hashCode();
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        if (smellingTask == null) {
+            return "UsabilitySmell(" + intensity + ", " + description.name() + ")";
+        }
+        else {
+            return "UsabilitySmell(" + smellingTask + ", " + intensity + ", " +
+                description.name() + ")";
+        }
+    }
+
+}
